package it.arnaldo.unibs.tamagolem;

import it.kibo.fp.lib.Menu;

import java.util.List;

public class Game {
    private final Player player1;
    private final Player player2;
    private final ElementGraph worldBalance;
    private boolean restart = false;

    public Game(Player player1, Player player2, ElementGraph worldBalance) {
        this.player1 = player1;
        this.player2 = player2;
        this.worldBalance = worldBalance;
    }

    public Player getPlayer1() {
        return player1;
    }

    public Player getPlayer2() {
        return player2;
    }

    public ElementGraph getWorldBalance() {
        return worldBalance;
    }

    public boolean isRestart() {
        return restart;
    }

    public void setRestart(boolean restart) {
        this.restart = restart;
    }

    public void start() {
        // N
        numberOfElements = worldBalance.getElements().size();

        // P
        numberOfStones = (int) Math.ceil((numberOfElements + 1) / 3.0) + 1;

        // G
        numberOfTamaGolems = (int) Math.ceil(((numberOfElements - 1) * (numberOfElements - 2)) / (2.0 * numberOfStones));

        // S
        totalNumberOfStones = (int) Math.ceil((2.0 * numberOfTamaGolems * numberOfStones));

        // Stones for each element
        numberOfStonesPerElement = totalNumberOfStones / numberOfElements;


        // deve essere uguale alla somma della potenza di tutti gli elementi
        totalPower = worldBalance.getTotalStrength();

        lifePoints = totalPower;

    }

    public void start() {
        setup();
        loop();
        worldBalance.printGraph();
    }

}
